# How to contribute

Hello and thanks for volunteering a contribution to this project.

Here are the **two main rules** we encurage you to follow:

1. Create a new branch for any new contribution/bug/feature
1. Follow the existing code style to keep a consistent code layout

## Fixing/Altering/Improving

Any proposal made should follow these basic rules:

* maintain backward compatibility with the existing APIs
* ask yourself if it's in the scope of this API or in the scope of your existing software
* if possible, don't narrow the browser support by using an exotic - hence useful - language feature
or a third-party library

## Submitting changes

In any case, **don't worry about making a mistake**. We will work things out with you,
by either adjusting the code or relocating it to a better place in the API.

Nonetheless:

* Submit the pull request
* Expect a code review from the maintainers of the project (even if the tests are *green*)
* Don't hesitate to bump the pull request issue if it's stagnating
* Courtesy. Always. We are humans, not machines
